### robocode

# Class Event

- `java.lang.Object`
- - `robocode.Event`

Implemented Interfaces:
  Comparable, Serializable

Known Direct Subclasses:
  BattleEndedEvent, BulletHitBulletEvent, BulletHitEvent, BulletMissedEvent, CustomEvent, DeathEvent, HitByBulletEvent, HitRobotEvent, HitWallEvent, KeyEvent, MessageEvent, MouseEvent, PaintEvent, RobotDeathEvent, ScannedRobotEvent, SkippedTurnEvent, StatusEvent, WinEvent

`public abstract class Event`
`extends Object`
`implements Comparable, Serializable`

The superclass of all Robocode events.

Authors:
  Mathew A. Nelson (original)
  Flemming N. Larsen (contributor)

  ## Constructor Summary

  `Event()`
    Called by the game to create a new Event.

  ## Method Summary

  `int`

  `compareTo(Event event)`
    Compares this event to another event regarding precedence.

  `int`

  `getPriority()`
    Returns the priority of this event.

  `long`

  `getTime()`
    Returns the time this event occurred.

## Constructor Details

### Event

    public Event()

> Called by the game to create a new Event.

## Method Details

### compareTo

    public int compareTo(Event event)

> Compares this event to another event regarding precedence. The event precedence is first and foremost determined by the event time, secondly the event priority, and lastly specific event information.

> This method will first compare the time of each event. If the event time is the same for both events, then this method compared the priority of each event. If the event priorities are equals, then this method will compare the two event based on specific event information.

> This method is called by the game in order to sort the event queue of a robot to make sure the events are listed in chronological order.

> Parameters:
>   `event` - the event to compare to this event.
> Returns:
>   a negative value if this event has higher precedence, i.e. must be listed before the specified event. A positive value if this event has a lower precedence, i.e. must be listed after the specified event. 0 means that the precedence of the two events are equal.

### getPriority

    public int getPriority()

> Returns the priority of this event. An event priority is a value from 0 - 99. The higher value, the higher priority. The default priority is 80.
> Returns:
>   the priority of this event

### getTime

    public final long getTime()

> Returns the time this event occurred.
> Returns:
>   the time this event occurred.